; GUI #
include win64a.inc
WS_EX_LAYERED equ 80000h
TIMER_ID = 10
W = 225
H = 95
.code
WinMain proc <20>
local msg:MSG

	xor	ebx,ebx	
	mov	esi,IMAGE_BASE
	mov	edi,offset AppName	
	mov	ecx,offset FileName
	invoke	LoadCursorFromFileA
	push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx
	push	COLOR_WINDOW
	push	rax	;hCursor
	push	rax    	;hIcon
	push	rsi	;hInstance
	push	rbx    	;cbClsExtra & cbWndExtra
	pushaddr WndProc  	;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
	mov	eax,esi	;rsi=400000h
	shl	esi,9	;rsi=400000h << 9=CW_USEDEFAULT
    	invoke	CreateWindowExA,WS_EX_LAYERED,edi,edi,WS_OVERLAPPED or WS_VISIBLE \
	or WS_CAPTION or WS_SYSMENU,rsi,rsi,W,H,rbx,rbx,rax,rbx
	lea	edi,msg
@@:	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
	jmp	@b
WinMain endp
WndProc proc <5> hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local	ps:PAINTSTRUCT
local	hdc:HDC
local	Time:SYSTEMTIME

	mov	hWnd,rcx

	cmp	edx,WM_CREATE
	je	wmCREATE
	cmp	edx,WM_PAINT
	je	wmPAINT
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	cmp	edx,WM_TIMER
	je	wmTIMER
	leave
        jmp	NtdllDefWindowProc_

wmDESTROY:;  #10
	invoke	KillTimer,,TIMER_ID
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke SetTimer,,TIMER_ID,1000,NULL
;   
	invoke	SetLayeredWindowAttributes,hWnd,0,180, LWA_ALPHA
wmTIMER:lea	ecx,Time
	invoke	GetLocalTime
	movzx	eax,Time.wSecond
	movzx	r9d,Time.wMinute
	movzx	r8d,Time.wHour
	mov	ecx,offset buffer
	lea	edx,fmtstr
	invoke	wsprintfA,,,,,rax
	invoke	InvalidateRect,hWnd,NULL,TRUE
	jmp	wmBYE
wmPAINT:lea	edx,ps
	invoke	BeginPaint;,hWnd
	mov	hdc,rax
	invoke	SetBkMode,eax,TRANSPARENT
	mov	ecx,offset lf
	invoke	CreateFontIndirect
	mov	hNewFont,rax
	invoke	SelectObject,hdc,eax
	mov	hOldFont,rax
	mov	r9d,offset buffer           ;line address
	invoke	TextOut,hdc,0,5,,8
	invoke	DeleteObject,hNewFont
	invoke	SelectObject,hdc,hOldFont
	lea	edx,ps
	invoke	EndPaint,hWnd
wmBYE:	leave
	retn
WndProc endp
.data
AppName		db ' #7f',0
FileName	db "br_Rabbit3.cur",0 
fmtstr		db "%02d:%02d:%02d",0
buffer		db 50 dup(?)
hOldFont	dq ?
hNewFont	dq ?
lf	LOGFONT <-64,0,0,0,FW_NORMAL,0,0,0,0,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,\
	DRAFT_QUALITY,VARIABLE_PITCH,"Fake Hope">
end